{ Books database
================
This application is a blueprint of the exercise found in the "Getting started"
section of the ILib help file.
}

unit form_main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ImageLibrary, Vcl.ComCtrls,
  Vcl.StdCtrls, Vcl.CheckLst, Vcl.ExtCtrls, Vcl.Buttons, Vcl.Menus,
  System.Actions, Vcl.ActnList, Vcl.ToolWin, ILActionBar;

type
  Tfrm_main = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    rec_Image: TILImage;
    PageControl1: TPageControl;
    clx_Workfields: TCheckListBox;
    Label1: TLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    dv_Titles: TILDatasetViewer;
    dv_Editions: TILDatasetViewer;
    cp_Search: TILControlPanel;
    cp_data: TILControlPanel;
    Panel3: TPanel;
    sb_Search: TSpeedButton;
    Panel4: TPanel;
    sb_Update: TSpeedButton;
    TM: TTableManager;
    data_Titles: TILData;
    pm_Image: TPopupMenu;
    Getimage1: TMenuItem;
    Clearimage1: TMenuItem;
    sb_Delete: TSpeedButton;
    ActionList1: TActionList;
    Update: TAction;
    Delete: TAction;
    GetImage: TAction;
    ClearImage: TAction;
    StatusBar1: TStatusBar;
    Search: TAction;
    TabSheet3: TTabSheet;
    dv_Portraits: TILDatasetViewer;
    data_Portraits: TILData;
    dat_Editions: TILData;
    ab_Portraits: TILActionBar;
    TBL_Titles: TILDataTable;
    TBL_AuthorPortraits: TILImageTable;
    TBL_Editions: TILDataTable;
    s_Title: TEdit;
    slbl_Title: TLabel;
    s_Authors: TEdit;
    slbl_Authors: TLabel;
    s_Genre: TCheckListBox;
    slbl_Genre: TLabel;
    s_Awards: TEdit;
    slbl_Awards: TLabel;
    s_Editor: TEdit;
    slbl_Editor: TLabel;
    s_Year: TEdit;
    slbl_Year: TLabel;
    s_Pages: TEdit;
    slbl_Pages: TLabel;
    s_Paperback: TCheckBox;
    slbl_Paperback: TLabel;
    d_Title: TEdit;
    dlbl_Title: TLabel;
    d_Authors: TMemo;
    dlbl_Authors: TLabel;
    d_Genre: TComboBox;
    dlbl_Genre: TLabel;
    d_Awards: TMemo;
    dlbl_Awards: TLabel;
    d_Editor: TEdit;
    dlbl_Editor: TLabel;
    d_Year: TEdit;
    dlbl_Year: TLabel;
    d_Pages: TEdit;
    dlbl_Pages: TLabel;
    d_Paperback: TCheckBox;
    dlbl_Paperback: TLabel;
    sb_New: TSpeedButton;
    procedure PageControl1Change(Sender: TObject);
    procedure TMLoaded(Sender: TObject);
    procedure sb_SearchClick(Sender: TObject);
    procedure sb_UpdateClick(Sender: TObject);
    procedure Getimage1Click(Sender: TObject);
    procedure Clearimage1Click(Sender: TObject);
    procedure sb_DeleteClick(Sender: TObject);
    procedure UpdateUpdate(Sender: TObject);
    procedure DeleteUpdate(Sender: TObject);
    procedure GetImageUpdate(Sender: TObject);
    procedure ClearImageUpdate(Sender: TObject);
    procedure SearchUpdate(Sender: TObject);
    procedure dv_TitlesClickCaption(Sender: TObject);
    procedure sb_NewClick(Sender: TObject);
    procedure ab_PortraitsDeleteQuery(Sender: TObject; var Accept: Boolean);
  private
    { Private declarations }
    FOldActive : TILTable;
  public
    { Public declarations }
  end;

var
  frm_main: Tfrm_main;

implementation
uses Clipbrd;

{$R *.dfm}

procedure Tfrm_main.SearchUpdate(Sender: TObject);
var
  Res : integer;
begin
    Res := TM.CanExecCommand(TM.CommandMode, ovDefault);
    if Res = 0 then
     Statusbar1.SimpleText := 'Ready'
   else
     Statusbar1.SimpleText := GetILErrorText(Res);
   Search.Enabled := Res = 0;
end;

procedure Tfrm_main.sb_NewClick(Sender: TObject);
begin
    TM.ActiveTable.DBWork.Insert;
end;

procedure Tfrm_main.ab_PortraitsDeleteQuery(Sender: TObject;
  var Accept: Boolean);
begin
   Accept := (MessageDlg('Delete record?', mtConfirmation, [mbYes, mbNo], mrNo) = mrYes);
end;

procedure Tfrm_main.Clearimage1Click(Sender: TObject);
begin
   rec_Image.Clear;
end;

procedure Tfrm_main.ClearImageUpdate(Sender: TObject);
begin
    ClearImage.Enabled := (TM.CommandMode = cmUpdate)
     and (rec_Image.DrawBitmap <> nil);
end;

procedure Tfrm_main.DeleteUpdate(Sender: TObject);
begin
     Delete.Enabled := (TM.ActiveRecord <> nil);
end;

procedure Tfrm_main.sb_DeleteClick(Sender: TObject);
begin
   if MessageDlg('Delete this record?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     TM.ActiveTable.Dataset.Delete(TM.ActiveRecord.Index);
end;

procedure Tfrm_main.Getimage1Click(Sender: TObject);
begin
    if TM.ActiveTable = TBL_Titles then
    // We allow Titles only to get the image from the image table
    begin
      with TM.ActiveTable as TILDataTable do
      begin
        if not GetFromImageTable(Tbl_Titles.FocusedRecord['Authors'].AsString, TM.ActiveRecord) then
          ShowMessage(Tbl_Titles.FocusedRecord['Authors'].AsString + ' not found in image table');
        // GetFromImageTable links an image to a record. Returns false if no match was found;
      end;
    end
    // Active table is Editions, try to get the image from the clipboard
    else if TM.ActiveTable = TBL_Editions then
    begin
      if Clipboard.HasFormat(CF_BITMAP) then
      begin
        rec_Image.LoadImage(CLIPBOARD_IMAGE);
        ClipBoard.Clear;
      end
      else
       ShowMessage('Image not available');
    end;
end;

procedure Tfrm_main.GetImageUpdate(Sender: TObject);
var
  Enabl : Boolean;
begin
  Enabl := (TM.CommandMode = cmUpdate);
  if Enabl and (TM.ActiveTable = Tbl_Titles) then
    Enabl := Assigned(Tbl_Titles.FocusedRecord)
    and (Tbl_Titles.FocusedRecord['Authors'].AsString <> '');
  GetImage.Enabled := Enabl;
end;

procedure Tfrm_main.dv_TitlesClickCaption(Sender: TObject);
begin
    if PageControl1.TabIndex = 2 then
      Exit;
    if Sender = dv_Titles then
      TM.ActiveTable := tbl_Titles
    else if Sender = dv_Portraits then
      TM.ActiveTable := tbl_AuthorPortraits
    else
      TM.ActiveTable := tbl_Editions
end;

procedure Tfrm_main.PageControl1Change(Sender: TObject);
begin
  if PageControl1.TabIndex = 0 then
  begin
    if FOldActive <> nil then
    begin
      TM.ActiveTable := FOldActive;
      FOldActive := nil;
    end;
    TM.CommandMode := cmSearch;
  end
  else if PageControl1.TabIndex = 1 then
  begin
   if FOldActive <> nil then
    begin
      TM.ActiveTable := FOldActive;
      FOldActive := nil;
    end;
    TM.CommandMode := cmUpdate;
  end
  else
  begin
    if TBL_AuthorPortraits.Dataset.Count <> TBL_AuthorPortraits.Count then
      TBL_AuthorPortraits.DBView.Search('select *');
    dv_Portraits.SetFocus;
    FOldActive := TM.ActiveTable;
    // Presereve the currently active table so we can revert to it when changing tab
    TM.ActiveTable := TBL_AuthorPortraits;
  end;
end;

procedure Tfrm_main.sb_SearchClick(Sender: TObject);
var
  Cnt : integer;
begin
     Cnt := TM.ExecCommand(ovDefault);
     if Cnt = 0 then
       ShowMessage('Not found');
end;

procedure Tfrm_main.sb_UpdateClick(Sender: TObject);
var
  Cnt : integer;
begin
     Cnt := TM.ExecCommand(ovDefault);
     begin
       ShowMessage(IntToStr(Cnt) + ' row(s) updated');
     end;
end;

procedure Tfrm_main.TMLoaded(Sender: TObject);
begin
   TM.Connected := True;
end;

procedure Tfrm_main.UpdateUpdate(Sender: TObject);
var
  Res : integer;
begin
   Res := TM.CanExecCommand(TM.CommandMode, ovDefault);
   Update.Enabled := Res = 0;
   if Res = 0 then
    Statusbar1.SimpleText := 'Ready'
   else
    Statusbar1.SimpleText := GetILErrorText(Res);
end;

end.
