{
BookStore demo
==============

This demo gives an example of how to use the TILMemTable and TILView components.
It also demonstrates the use of cross path links in many to many relationships.
The tables OrderLines and Authorships both link to tables in different paths.
}

unit form_main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ImageLibrary, Vcl.ComCtrls, Vcl.ExtCtrls,
  Vcl.StdCtrls, Vcl.Buttons, Vcl.CheckLst, Vcl.ToolWin, ILActionBar,
  System.ImageList, Vcl.ImgList;

type
  Tfrm_Bookstore = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    pg_Main: TPageControl;
    tab_Titles: TTabSheet;
    pan_TitleData: TPanel;
    dv_TitleAuthor: TILDatasetViewer;
    tab_Authors: TTabSheet;
    cp_TitleData: TILControlPanel;
    cp_TitleSearch: TILControlPanel;
    TM: TTableManager;
    TBL_Authors: TILDataTable;
    TBL_Authorships: TILDataTable;
    TBL_Editions: TILDataTable;
    TBL_AuthorPortraits: TILImageTable;
    dat_Titles: TILData;
    Label1: TLabel;
    dat_AuthorTitle: TILData;
    abar: TILActionBar;
    dat_Authors: TILData;
    dv_Authors: TILDatasetViewer;
    TBL_Customers: TILDataTable;
    TBL_Orders: TILDataTable;
    tab_Store: TTabSheet;
    dat_Editions: TILData;
    dv_Editions: TILDatasetViewer;
    pan_Customer: TPanel;
    cp_Customer: TILControlPanel;
    dat_Customer: TILData;
    d_Name: TEdit;
    dlbl_Name: TLabel;
    d_Email: TEdit;
    dlbl_Email: TLabel;
    d_Adress: TMemo;
    dlbl_Adress: TLabel;
    ILControlPanel1: TILControlPanel;
    s_Name: TEdit;
    slbl_Name: TLabel;
    s_Email: TEdit;
    slbl_Email: TLabel;
    s_Adress: TEdit;
    slbl_Adress: TLabel;
    s_Phone: TEdit;
    slbl_Phone: TLabel;
    Label3: TLabel;
    dat_Orders: TILData;
    dv_Orders: TILDatasetViewer;
    Panel3: TPanel;
    Panel4: TPanel;
    dv_OrderLines: TILDatasetViewer;
    dat_OrderLines: TILData;
    cp_AuthorSearch: TILControlPanel;
    cp_AuthorData: TILControlPanel;
    d_AuthorName: TEdit;
    dlbl_AuthorName: TLabel;
    d_BornDate: TDateTimePicker;
    dlbl_BornDate: TLabel;
    d_DiedDate: TDateTimePicker;
    dlbl_DiedDate: TLabel;
    s_AuthorName: TEdit;
    slbl_AuthorName: TLabel;
    Label4: TLabel;
    img_Author: TILImage;
    tab_Sources: TTabSheet;
    pan_Genres: TPanel;
    pan_Portraits: TPanel;
    dv_Genres: TILDatasetViewer;
    dv_Portraits: TILDatasetViewer;
    img_Portraits: TILImage;
    dat_Portraits: TILData;
    img_Edition: TILImage;
    img_SharedAuthor: TILImage;
    TBL_OrderLines: TILDataTable;
    TBL_Store: TILDataTable;
    TBL_Titles: TILDataTable;
    TBL_Genres: TILLookupTable;
    d_TitleName: TEdit;
    dlbl_TitleName: TLabel;
    d_Genre: TComboBox;
    dlbl_Genre: TLabel;
    d_FirstPublishedYear: TEdit;
    dlbl_FirstPublishedYear: TLabel;
    d_Awards: TMemo;
    dlbl_Awards: TLabel;
    s_TitleName: TEdit;
    slbl_TitleName: TLabel;
    s_Author: TEdit;
    slbl_Author: TLabel;
    d_Phone: TEdit;
    dlbl4_Phone: TLabel;
    pan_Recordstate: TPanel;
    dat_Genres: TILData;
    view_Data: TILData;
    View_Ed: TILView;
    dv_ViewEd: TILDatasetViewer;
    s_VTitle: TEdit;
    Label5: TLabel;
    sb_VSearch: TSpeedButton;
    ILControlPanel2: TILControlPanel;
    Label6: TLabel;
    s_Paydate: TEdit;
    slbl_Paydate: TLabel;
    s_Shipped: TEdit;
    slbl_Shipped: TLabel;
    s_OrderNumber: TEdit;
    slbl_OrderNumber: TLabel;
    s_RegDate: TEdit;
    slbl_RegDate: TLabel;
    mt_Payments: TILMemTable;
    dat_Payments: TILData;
    SpeedButton1: TSpeedButton;
    pan_TitleCap: TPanel;
    ImageList1: TImageList;
    Memo2: TMemo;
    slbl6_Awards: TLabel;
    ILMessageBar1: TILMessageBar;
    sb_BookManagement: TSpeedButton;
    sb_Customers: TSpeedButton;
    sb_Authors: TSpeedButton;
    sb_Additionals: TSpeedButton;
    pan_CustCap: TPanel;
    Memo1: TMemo;
    SpeedButton6: TSpeedButton;
    e_ScriptFolder: TEdit;
    Label2: TLabel;
    procedure TMLoaded(Sender: TObject);
    procedure TMActivateTable(Sender: TObject);
    procedure dv_TitleAuthorClick(Sender: TObject);
    procedure dat_AuthorTitleInitRecord(Sender: TObject;
      Operation: TDBOperation; Rec: TILDataRecord);
    procedure dv_EditionsClickCaption(Sender: TObject);
    procedure dv_OrdersClickCaption(Sender: TObject);
    procedure dv_OrderLinesClickCaption(Sender: TObject);
    procedure dat_OrderLinesInitRecord(Sender: TObject; Operation: TDBOperation;
      Rec: TILDataRecord);
    procedure dat_OrdersInitRecord(Sender: TObject; Operation: TDBOperation;
      Rec: TILDataRecord);
    procedure dat_OrdersCalcField(Sender: TObject; Data: TILDataRecord;
      Field: TILField);
    procedure dv_PortraitsClickCaption(Sender: TObject);
    procedure dv_GenresClickCaption(Sender: TObject);
    procedure dat_OrderLinesDatasetChange(Sender: TObject;
      const Change: TDatasetChange);
    procedure sb_VSearchClick(Sender: TObject);
    procedure mt_PaymentsInvalidateTable(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure pan_TitleCapClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sb_BookManagementClick(Sender: TObject);
    procedure sb_CustomersClick(Sender: TObject);
    procedure sb_AuthorsClick(Sender: TObject);
    procedure sb_AdditionalsClick(Sender: TObject);
    procedure pan_CustCapClick(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
  private
    { Private declarations }
    FActives : array[0..3] of TILTable; { Active table log}
  public
    { Public declarations }
  end;

var
  frm_Bookstore: Tfrm_Bookstore;

implementation
uses VCL.ActnList, DateUtils, form_Payments, ILMessages;

{$R *.dfm}

procedure Tfrm_Bookstore.dat_AuthorTitleInitRecord(Sender: TObject;
  Operation: TDBOperation; Rec: TILDataRecord);
{ Initiates the title field in the authorships link table. Picks the title id from the
focused record of the Titles table}
begin
  if TBL_Titles.FocusedRecord = nil then
    raise Exception.Create('Misssing title');
  if Rec['Title'].IsEmpty then
   Rec['Title'].AsInteger := TBL_Titles.FocusedRecord['TitleID'].AsInteger;
end;

procedure Tfrm_Bookstore.dat_OrderLinesDatasetChange(Sender: TObject;
  const Change: TDatasetChange);
{Recaclulates the the focused record in TBL_Orders when and order item is saved.
In this case the field Price is defined as calculated. It accumulates the price of
the order lines }
begin
   if Change = dsSaved then
   begin
    TBL_Orders.FocusedRecord.CalcFields;
    dv_Orders.Invalidate;
   end;
end;

procedure Tfrm_Bookstore.dat_OrderLinesInitRecord(Sender: TObject;
  Operation: TDBOperation; Rec: TILDataRecord);
{ Initiates the order field in the orderlines link table. Picks the orderid from the
focused record of its master table orders}
begin
  if TBL_Orders.FocusedRecord = nil then
    raise Exception.Create('Missing order');
  Rec['Order'].AsInteger := TBL_Orders.FocusedRecord['OrderID'].AsInteger;
end;

procedure Tfrm_Bookstore.dat_OrdersCalcField(Sender: TObject;
  Data: TILDataRecord; Field: TILField);
{ Performs calculation of the price field in the orders table. Accumulates the values from the
  price field in the orderlines table}
var
  ID, EdID : integer;
  S : string;
  DSItm, DSEdition : TILDataset;
  i : integer;
  Amnt : Extended;
begin
   Amnt := 0;
   ID := Data['OrderID'].AsInteger;
   { Get  the items }
   S := 'select * where Order = ' + IntToStr(ID);
   DSItm := TBL_OrderLines.DBView.SearchPrivate(S);
   try
   for  i := 0 to DSItm.Count-1 do
   begin
      EdId := DSItm[i]['Title'].AsInteger;
      S := 'select * where EditionID = ' + IntToStr(EdID);
      DSEdition := TBL_Editions.DBView.SearchPrivate(S);
      try
      Amnt := Amnt + DSEdition[0]['Price'].AsNumber;
      finally
        DSEdition.Free;
      end;
   end;
   finally
     DSItm.Free;
   end;
   Field.AsString := FloatToStrF(Amnt, ffNumber, 5, 2 );

end;

procedure Tfrm_Bookstore.dat_OrdersInitRecord(Sender: TObject;
  Operation: TDBOperation; Rec: TILDataRecord);
begin
  Rec['OrderNumber'].AsString := IntToStr(Rec['OrderID'].AsInteger);
end;

procedure Tfrm_Bookstore.dv_GenresClickCaption(Sender: TObject);
begin
   TM.ActiveTable := TBL_Genres;
end;

procedure Tfrm_Bookstore.dv_PortraitsClickCaption(Sender: TObject);
begin
  TM.ActiveTable := TBL_AuthorPortraits;
end;

procedure Tfrm_Bookstore.dv_TitleAuthorClick(Sender: TObject);
begin
  TM.ActiveTable := TBL_Authorships;
end;

procedure Tfrm_Bookstore.FormCreate(Sender: TObject);
begin
  FActives[0] := TBL_Titles;
  FActives[1] := TBL_Customers;
  FActives[2] := TBL_Authors;
  FActives[3] := TBL_Genres;

end;

procedure Tfrm_Bookstore.sb_VSearchClick(Sender: TObject);
{ The View_Ed component introduces a seconadry view on the editions table. Used
to make the user capable of selecting the correct edition when there are more
than one edition registred }
var
  R : integer;
begin
     R := View_Ed.DBView.Search('select * where titles.titlename = ' + '''' + s_VTitle.Text + '''');
end;

procedure Tfrm_Bookstore.SpeedButton1Click(Sender: TObject);
begin
  frm_Payments.ShowModal;
end;

procedure Tfrm_Bookstore.sb_BookManagementClick(Sender: TObject);
{ Setting the active table when a task i selected, using the active table log }
begin
  FActives[pg_Main.ActivePage.PageIndex] := TM.ActiveTable;
  pg_Main.ActivePage.TabVisible := false;
  pg_Main.Pages[0].TabVisible := True;
  pg_Main.TabIndex := 0;
  TM.ActiveTable := FActives[0];
end;

procedure Tfrm_Bookstore.sb_CustomersClick(Sender: TObject);
{ Setting the active table when a task i selected, using the active table log }
begin
  FActives[pg_Main.ActivePage.PageIndex] := TM.ActiveTable;
  pg_Main.ActivePage.TabVisible := false;
  pg_Main.Pages[1].TabVisible := True;
  pg_Main.TabIndex := 0;
  TM.ActiveTable := FActives[1];
end;

procedure Tfrm_Bookstore.sb_AuthorsClick(Sender: TObject);
{ Setting the active table when a task i selected, using the active table log }
begin
  FActives[pg_Main.ActivePage.PageIndex] := TM.ActiveTable;
  pg_Main.ActivePage.TabVisible := false;
  pg_Main.Pages[2].TabVisible := True;
  pg_Main.TabIndex := 0;
  TM.ActiveTable := FActives[2];
end;

procedure Tfrm_Bookstore.sb_AdditionalsClick(Sender: TObject);
{ Setting the active table when a task i selected, using the active table log }
begin
  FActives[pg_Main.ActivePage.PageIndex] := TM.ActiveTable;
  pg_Main.ActivePage.TabVisible := false;
  pg_Main.Pages[3].TabVisible := True;
  pg_Main.TabIndex := 0;
  TM.ActiveTable := FActives[3];
end;

procedure Tfrm_Bookstore.SpeedButton6Click(Sender: TObject);
{ Populate proc. Delete it when finished }
var
  Dir : string;
  Res : integer;
  Err : integer;
begin
   if MessageDlg('Run script?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
     Exit;
   if not FileExists(e_Scriptfolder.Text + '\BookStoreInsert.txt') then
    raise Exception.Create('Could not find script file ' + e_Scriptfolder.Text + '\BookStoreInsert.txt');
   Dir := GetCurrentDir;
   ChDir(e_Scriptfolder.Text);
   Res := TM.ExecScript('BookStoreInsert.txt', Err);
   if Err = 0 then
   begin
     TBL_Titles.DBView.Search;
     ShowMessage('Success!');
   end
   else
     ShowMessage('An error occured at element ' + IntToStr(Err) + ' in the file BookStoreInsert.txt. Message : ' +
      GetILErrorText(Res));
   ChDir(Dir);
end;

procedure Tfrm_Bookstore.TMActivateTable(Sender: TObject);
{Highlighting control panels of the active table }
var
  ac : TAction;
  T : TToolbutton;
begin
  if TM.ActiveTable <> tbl_Titles then
  begin
    pan_TitleCap.Color := clInactiveCaption;
    pan_TitleCap.Font.Color := clWindowText;
  end;
  if TM.ActiveTable <> tbl_Customers then
  begin
    pan_CustCap.Color := clInactiveCaption;
    pan_CustCap.Font.Color := clWindowText;
  end;
  if TM.ActiveTable = TBL_Titles then
  begin
   pan_TitleCap.Color := clHighLight;
   pan_TitleCap.Font.Color := clWhite;
  end;
  if TM.ActiveTable = TBL_Customers then
  begin
   pan_CustCap.Color := clHighLight;
   pan_CustCap.Font.Color := clWhite;
  end;
end;

procedure Tfrm_Bookstore.dv_EditionsClickCaption(Sender: TObject);
begin
  TM.ActiveTable := TBL_EDitions;
end;

procedure Tfrm_Bookstore.dv_OrdersClickCaption(Sender: TObject);
begin
  TM.ActiveTable := TBL_Orders
end;

procedure Tfrm_Bookstore.dv_OrderLinesClickCaption(Sender: TObject);
begin
  TM.ActiveTable := TBL_OrderLines;
end;

procedure Tfrm_Bookstore.mt_PaymentsInvalidateTable(Sender: TObject);
{ Maintaing the mt_Payments mem table. Handles payment reminders.
This handler fires every time the content of the Orders table changes. }
var
  T : TILMemTable;
  DS, DS2 : TILDataSet;
  i, j : Integer;
  R : TILDataRecord;

  procedure SetBaseValues(SuppressOutput : Boolean);
  begin
     { SuppressOutput = True supresses duplicate values }
     R['Customer'].SuppressOutput := SuppressOutput;
     R['Shipped'].SuppressOutput := SuppressOutput;
     R['Amount'].SuppressOutput := SuppressOutput;
     R['CustomerID'].SuppressOutput := SuppressOutput;
     R['UnpaidDays'].SuppressOutput := SuppressOutput;

     R['Customer'].AsString := DS[i]['Name'].AsString;
     R['Shipped'].AsString := DS[i]['Orders.Shipped'].AsString;
     R['Amount'].AsNumber := StrToFloat(DS[i]['Orders.Price'].AsString);
     R['CustomerID'].AsString := DS[i]['CustID'].AsString;
     R['UnpaidDays'].AsInteger := DaysBetween(Today,DS[i]['Orders.Shipped'].AsDateTime);
  end;
begin
  T := Sender as TILMemTable;
  T.TableRecords.Clear;
  { Get unpaid orders, joining customers and orders }
  DS := TBL_Customers.DBView.SearchPrivate('select *, orders.shipped, orders.paydate, orders.price, orders.orderid ' +
   'where orders.shipped <> null and orders.paydate = null');
  try
  for I := 0 to DS.Count-1 do
  begin
     R := T.DBWork.CreateDataRecord;
     SetBaseValues(False);
     DS2 := TBL_Editions.DBView.SearchPrivate
      ('select Title, Orderlines.Title where orderlines.order = ' + DS[i]['Orders.OrderID'].AsString);
     try
        R['Title'].AsString := DS2[0]['Title'].AsString;
        T.TableRecords.Add(R);
        { For each unpaid order get the order items}
        for j := 1 to DS2.Count-1 do
        begin
          R := T.DBWork.CreateDataRecord;
          R['Title'].AsString := DS2[j]['Title'].AsString;
          SetBaseValues(True);
         T.TableRecords.Add(R);
        end;
     finally
       DS2.Free;
     end;
  end;
  finally
    DS.Free;
  end;
end;

procedure Tfrm_Bookstore.pan_CustCapClick(Sender: TObject);
begin
  TM.ActiveTable := TBL_Customers;
end;

procedure Tfrm_Bookstore.pan_TitleCapClick(Sender: TObject);
begin
   TM.ActiveTable := tbl_Titles;
end;

procedure Tfrm_Bookstore.TMLoaded(Sender: TObject);
{Initializing the db components. Note that this must be done in the OnLoaded event handler}
begin
  TM.Connected := True;
  TBL_Store.DBView.Search;
  {Get the root table record. This must be loaded in order to connect new titles, customers and authors,
  all of which are children of the root table.
  The root table ("Store") can only have one record, according the set setting of the Relations property in the ILib designer}
  TM.CommandMode := cmUpdate;
  { We set commandmode permanently to cmUpdate. Searching is made available by allowing FreeSearch for each table}
  TM.ActiveTable := TBL_Titles;
end;

end.
